stages:
  - test
  - build
  - deploy

lint:
  image: python:3.10
  stage: test

  cache:
    paths:
      - .cache/pre-commit

  except:
    - schedules

  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
    PRE_COMMIT_HOME: "$CI_PROJECT_DIR/.cache/pre-commit"

  before_script:
    - pip install pre-commit

  script:
    - pre-commit run -a

test:
  image: python:3.10

  stage: test
  cache:
    paths:
      - .cache/pip

  variables:
    PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"
    ARKINDEX_API_SCHEMA_URL: schema.yml

  before_script:
    - pip install tox

    # Download OpenAPI schema from last backend build
    - curl https://assets.teklia.com/arkindex/openapi.yml > schema.yml

    # Add system deps for opencv
    - apt-get update -q
    - apt-get install -q -y libgl1

  except:
    - schedules

  script:
    - tox

# Make sure docs still build correctly
.docs:
  image: python:3.10
  artifacts:
    paths:
      - public

  before_script:
    - pip install -e .[docs]

  script:
    - mkdocs build --strict --verbose

docs-build:
  extends: .docs
  stage: build

  # Test job outside of tags to ensure the docs still can build before merging
  # Does not use the `pages` name, therefore will be ignored by GitLab Pages
  except:
    - tags
    - schedules

pages:
  extends: .docs
  stage: deploy

  only:
    - main
    - tags


docs-deploy:
  image: node:18
  stage: deploy

  dependencies:
    - docs-build

  before_script:
    - npm install -g surge

  except:
    - main
    - tags
    - schedules

  environment:
    name: ${CI_COMMIT_REF_SLUG}
    url: https://${CI_COMMIT_REF_SLUG}-teklia-atr-dan.surge.sh
    on_stop: docs-stop-surge

  script:
    - surge public ${CI_ENVIRONMENT_URL}

docs-stop-surge:
  image: node:18
  stage: deploy
  when: manual

  # Do not try to checkout the branch if it was deleted
  variables:
    GIT_STRATEGY: none

  except:
    - main
    - tags
    - schedules

  environment:
    name: ${CI_COMMIT_REF_SLUG}
    url: https://${CI_COMMIT_REF_SLUG}-teklia-atr-dan.surge.sh
    action: stop

  before_script:
    - npm install -g surge

  script:
    - surge teardown ${CI_ENVIRONMENT_URL}

bump-python-deps:
  stage: deploy
  image: registry.gitlab.com/teklia/devops:latest

  only:
    - schedules

  script:
    - devops python-deps requirements.txt doc-requirements.txt

release-notes:
  stage: deploy
  image: registry.gitlab.com/teklia/devops:latest

  rules:
    - if: '$CI_COMMIT_TAG'
      when: on_success
    - when: never

  script:
    - devops release-notes
